Unit GraphObj;
Interface
Type
  TGraphObj = Object
              Private
                     X,Y:Integer;   Color:Word;
              Public
                    Constructor Init (aX,aY:Integer;aColor:Word);
                    Procedure Draw (aColor:Word);Virtual;
                    Procedure Show;
                    Procedure Hide;
                    Procedure MoveTo(dX,dY: Integer);
              End;
    TPoint = Object (TGraphObj)
                     Procedure Draw (aColor:Word);Virtual;
             End;
    TLine = Object (TGraphObj)
              dX,dY: Integer;
              Constructor Init (X1,Y1,X2,Y2: Integer; aColor: Word);
              Procedure Draw (aColor: Word); Virtual;
            End;
    TRect = Object (TLine)
              Procedure Draw (aColor: Word);Virtual;
            End;
    TCircle = Object (TGraphObj)
                R: Integer;
                Constructor Init (aX,aY,aR: Integer; aColor: Word);
                Procedure Draw (aColor: Word);Virtual;
              End;

Implementation
Uses Graph;

   Constructor TGraphObj.Init;
   Begin
     X:=aX;
     Y:=aY;
     Color:=aColor;
   End;

   Procedure TGraphObj.Draw;
   Begin
   End;

   Procedure TGraphObj.Show;
   Begin
     Draw(Color);
   End;

   Procedure TGraphObj.Hide;
   Begin
     Draw(GetBkColor);
   End;

   Procedure TGraphObj.MoveTo;
   Begin
     Hide;
     X:=X+dX;
     Y:=Y+dY;
     Show;
   End;

   Procedure TPoint.Draw;
   Begin
     PutPixel(X,Y,Color);
   End;

   Constructor TLine.Init;
   Begin
     Inherited Init(X1,Y1,aColor);
     dX:=X2-X1;
     dY:=Y2-Y1;
   End;

   Procedure TLine.Draw;
   Begin
     SetColor(aColor);
     Line(X,Y,X+dX,Y+dY);
   End;

   Procedure TRect.Draw;
   Begin
     SetColor(aColor);
     Rectangle(X,Y,X+dX,Y+dY);
   End;

   Constructor TCircle.Init;
   Begin
     Inherited Init(aX,aY,aColor);
     R:=aR;
   End;

   Procedure TCircle.Draw;
   Begin
     SetColor(aColor);
     Circle(X,Y,R);
   End;
End.
